2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
6 # SPDX-License-Identifier: GPL-2.0+
10 # if exiting with 0, write to stdout, else write to stderr
12 [ "${ret}" -eq 1 ] && exec 1>&2
14 Usage: MAKEALL [options] [--] [boards-to-build]
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
36 If no boards are specified, then the default is "powerpc".
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1)
49 - build all Power Architecture boards:
51 MAKEALL --arch powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
66 # Option processing based on util-linux-2.13/getopt-parse.bash
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
75 [ $? != 0 ] && usage 1
77 # Note the quotes around `$TEMP': they are essential!
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
94 opt_a="(\$2 == \"$2\")"
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
121 opt_v="(\$5 == \"$2\")"
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
162 echo "Internal error!" >&2 ; exit 1 ;;
166 GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
171 # echo "Remaining arguments:"
172 # for arg do echo '--> '"\`$arg'" ; done
174 if [ ! -r boards.cfg ]; then
175 echo "Could not find boards.cfg"
176 tools/genboardscfg.py || {
177 echo "Failed to generate boards.cfg" >&2
183 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
184 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
185 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
186 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
187 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
189 if [ "$SELECTED" ] ; then
190 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
192 # Make sure some boards from boards.cfg are actually found
193 if [ -z "$SELECTED" ] ; then
194 echo "Error: No boards selected, invalid arguments"
199 #########################################################################
201 # Print statistics when we exit
205 # Determine number of CPU cores if no default was set
206 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
208 if [ "$BUILD_NCPUS" -gt 1 ]
210 JOBS="-j $((BUILD_NCPUS + 1))"
215 if [ "${MAKEALL_LOGDIR}" ] ; then
216 LOG_DIR=${MAKEALL_LOGDIR}
221 : ${BUILD_NBUILDS:=1}
224 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
226 : ${BUILD_DIR:=./build}
227 mkdir -p "${BUILD_DIR}/ERR"
228 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
233 OUTPUT_PREFIX="${BUILD_DIR}"
235 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
236 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
237 find "${LOG_DIR}/" -type f -exec rm -f {} +
242 # Keep track of the number of builds and errors
253 # Helper funcs for parsing boards.cfg
259 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
263 targets_by_arch() { targets_by_field 2 "$@" ; }
264 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
265 targets_by_soc() { targets_by_field 4 "$@" ; }
267 #########################################################################
269 #########################################################################
271 LIST_5xx="$(targets_by_cpu mpc5xx)"
273 #########################################################################
275 #########################################################################
277 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
279 #########################################################################
281 #########################################################################
283 LIST_512x="$(targets_by_cpu mpc512x)"
285 #########################################################################
287 #########################################################################
289 LIST_8xx="$(targets_by_cpu mpc8xx)"
291 #########################################################################
293 #########################################################################
295 LIST_4xx="$(targets_by_cpu ppc4xx)"
297 #########################################################################
299 #########################################################################
301 LIST_824x="$(targets_by_cpu mpc824x)"
303 #########################################################################
304 ## MPC8260 Systems (includes 8250, 8255 etc.)
305 #########################################################################
307 LIST_8260="$(targets_by_cpu mpc8260)"
309 #########################################################################
310 ## MPC83xx Systems (includes 8349, etc.)
311 #########################################################################
313 LIST_83xx="$(targets_by_cpu mpc83xx)"
315 #########################################################################
316 ## MPC85xx Systems (includes 8540, 8560 etc.)
317 #########################################################################
319 LIST_85xx="$(targets_by_cpu mpc85xx)"
321 #########################################################################
323 #########################################################################
325 LIST_86xx="$(targets_by_cpu mpc86xx)"
327 #########################################################################
329 #########################################################################
331 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
333 #########################################################################
335 #########################################################################
357 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
358 # still using "ppc" instead of "powerpc"
363 #########################################################################
365 #########################################################################
367 LIST_SA="$(targets_by_cpu sa1100)"
369 #########################################################################
371 #########################################################################
373 LIST_ARM7="$(targets_by_cpu arm720t)"
375 #########################################################################
377 #########################################################################
379 LIST_ARM9="$(targets_by_cpu arm920t) \
380 $(targets_by_cpu arm926ejs) \
381 $(targets_by_cpu arm946es) \
384 #########################################################################
386 #########################################################################
387 LIST_ARM11="$(targets_by_cpu arm1136) \
388 $(targets_by_cpu arm1176) \
391 #########################################################################
393 #########################################################################
395 LIST_ARMV7="$(targets_by_cpu armv7)"
397 #########################################################################
399 #########################################################################
401 LIST_ARMV8="$(targets_by_cpu armv8)"
403 #########################################################################
405 #########################################################################
407 LIST_at91="$(targets_by_soc at91)"
409 #########################################################################
411 #########################################################################
413 LIST_pxa="$(targets_by_cpu pxa)"
415 #########################################################################
417 #########################################################################
419 LIST_spear="$(targets_by_soc spear)"
421 #########################################################################
423 #########################################################################
425 LIST_arm="$(targets_by_arch arm | \
426 for ARMV8_TARGET in $LIST_ARMV8; \
427 do sed "/$ARMV8_TARGET/d"; \
431 #########################################################################
432 ## MIPS Systems (default = big endian)
433 #########################################################################
435 LIST_mips="$(targets_by_arch mips)"
437 #########################################################################
439 #########################################################################
441 LIST_openrisc="$(targets_by_arch openrisc)"
443 #########################################################################
445 #########################################################################
447 LIST_x86="$(targets_by_arch x86)"
449 #########################################################################
451 #########################################################################
453 LIST_nios2="$(targets_by_arch nios2)"
455 #########################################################################
456 ## MicroBlaze Systems
457 #########################################################################
459 LIST_microblaze="$(targets_by_arch microblaze)"
461 #########################################################################
463 #########################################################################
465 LIST_m68k="$(targets_by_arch m68k)"
466 LIST_coldfire=${LIST_m68k}
468 #########################################################################
470 #########################################################################
472 LIST_avr32="$(targets_by_arch avr32)"
474 #########################################################################
476 #########################################################################
478 LIST_blackfin="$(targets_by_arch blackfin)"
480 #########################################################################
482 #########################################################################
484 LIST_sh2="$(targets_by_cpu sh2)"
485 LIST_sh3="$(targets_by_cpu sh3)"
486 LIST_sh4="$(targets_by_cpu sh4)"
488 LIST_sh="$(targets_by_arch sh)"
490 #########################################################################
492 #########################################################################
494 LIST_sparc="$(targets_by_arch sparc)"
496 #########################################################################
498 #########################################################################
500 LIST_nds32="$(targets_by_arch nds32)"
502 #########################################################################
504 #########################################################################
506 LIST_arc="$(targets_by_arch arc)"
508 #-----------------------------------------------------------------------
510 get_target_location() {
518 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
519 if [ -z "${line}" ] ; then echo "" ; return ; fi
523 CONFIG_NAME="${7%_defconfig}"
525 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
527 if [ $# -gt 5 ]; then
528 if [ "$6" = "-" ] ; then
535 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
536 [ $# -gt 6 ] && [ "$8" != "-" ] && {
543 # Assign board directory to BOARDIR variable
544 if [ "${vendor}" == "-" ] ; then
547 BOARDDIR=${vendor}/${board}
550 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
553 get_target_maintainers() {
554 local name=`echo $1 | cut -d : -f 3`
556 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
557 if [ -z "${line}" ]; then
562 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
563 [ "$mails" == "-" ] && mails=""
571 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
573 if [ -z "${line}" ] ; then echo "" ; return ; fi
580 if [ "$PRINT_MAINTS" != 'y' ] ; then
587 local loc=`get_target_location $1`
589 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
591 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
593 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
595 local dir=`echo ${loc} | cut -d ":" -f 2`
596 local cfg=`echo ${loc} | cut -d ":" -f 1`
597 local git_result=`git log --format=%aE board/${dir} \
598 include/configs/${cfg}.h | grep "@"`
599 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
601 local git_result_top=`echo ${git_result} | tr " " "\n" | \
602 sort | uniq -c | sort -nr | head -n 3 | \
603 sed "s/^ \+[0-9]\+ \+//"`
605 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
606 sort -u | tr "\n" " " | sed "s/ $//" ;
608 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
615 # Each finished build will have a file called ${donep}${n},
616 # where n is the index of the build. Each build
617 # we've already noted as finished will have ${skipp}${n}.
618 # The code managing the build process will use this information
619 # to ensure that only BUILD_NBUILDS builds are in flight at once
620 donep="${LOG_DIR}/._done_"
621 skipp="${LOG_DIR}/._skip_"
623 build_target_killed() {
624 echo "Aborted $target build."
625 # Remove the logs for this board since it was aborted
626 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
634 if [ "$ONLY_LIST" == 'y' ] ; then
635 list_target ${target}
639 if [ $BUILD_MANY == 1 ] ; then
640 output_dir="${OUTPUT_PREFIX}/${target}"
641 mkdir -p "${output_dir}"
642 trap build_target_killed TERM
644 output_dir="${OUTPUT_PREFIX}"
647 target_arch=$(get_target_arch ${target})
648 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
649 if [ "${cross_toolchain}" ] ; then
650 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
651 elif [ "${CROSS_COMPILE}" ] ; then
652 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
657 if [ "${output_dir}" != "." ] ; then
658 MAKE="${MAKE} O=${output_dir}"
661 ${MAKE} distclean >/dev/null
663 echo "Building ${target} board..."
664 ${MAKE} -s ${target}_defconfig >/dev/null
666 ${MAKE} ${JOBS} ${CHECK} all \
667 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
669 # Check for 'make' errors
670 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
674 if [ $BUILD_MANY == 1 ] ; then
679 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
680 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
682 rm ${LOG_DIR}/${target}.ERR
685 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
686 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
687 : $(( ERR_CNT += 1 ))
688 ERR_LIST="${ERR_LIST} $target"
690 : $(( WRN_CNT += 1 ))
691 WRN_LIST="${WRN_LIST} $target"
694 rm ${LOG_DIR}/${target}.ERR
698 OBJS=${output_dir}/u-boot
699 if [ -e ${output_dir}/spl/u-boot-spl ]; then
700 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
703 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
705 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
707 touch "${donep}${build_idx}"
711 search_idx=${OLDEST_IDX}
712 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
715 if [ -e "${donep}${search_idx}" ] ; then
716 : $(( CURRENT_CNT-- ))
717 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
718 : $(( OLDEST_IDX++ ))
720 # Only want to count it once
721 rm -f "${donep}${search_idx}"
722 touch "${skipp}${search_idx}"
723 elif [ -e "${skipp}${search_idx}" ] ; then
724 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
725 : $(( OLDEST_IDX++ ))
727 : $(( search_idx++ ))
728 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
729 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
730 search_idx=${OLDEST_IDX}
741 # If a LIST_xxx var exists, use it. But avoid variable
742 # expansion in the eval when a board name contains certain
743 # characters that the shell interprets.
746 *) list=$(eval echo '${LIST_'$t'}') ;;
748 if [ -n "${list}" ] ; then
749 build_targets ${list}
751 : $((TOTAL_CNT += 1))
752 : $((CURRENT_CNT += 1))
753 rm -f "${donep}${TOTAL_CNT}"
754 rm -f "${skipp}${TOTAL_CNT}"
755 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
757 touch "${donep}${TOTAL_CNT}"
758 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
760 touch "${donep}${TOTAL_CNT}"
762 if [ $BUILD_MANY == 1 ] ; then
763 build_target ${t} ${TOTAL_CNT} &
766 build_target ${t} ${TOTAL_CNT}
772 # We maintain a running count of all the builds we have done.
773 # Each finished build will have a file called ${donep}${n},
774 # where n is the index of the build. Each build
775 # we've already noted as finished will have ${skipp}${n}.
776 # We track the current index via TOTAL_CNT, and the oldest
777 # index. When we exceed the maximum number of parallel builds,
778 # We look from oldest to current for builds that have completed,
779 # and update the current count and oldest index as appropriate.
780 # If we've gone through the entire list, wait a second, and
781 # reprocess the entire list until we find a build that has
783 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
789 #-----------------------------------------------------------------------
796 # Mac OS X is known to have BSD style ps
797 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
798 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
801 # everything else tries the GNU style
802 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
803 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
807 kill $children 2> /dev/null
808 wait $children 2> /dev/null
814 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
816 # Only count boards that completed
817 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
819 rm -f ${donep}* ${skipp}*
821 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
822 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
823 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
824 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
825 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
826 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
827 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
829 # Remove the logs for any board that was interrupted
830 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
833 : $((TOTAL_CNT -= ${SKIP_CNT}))
835 echo "--------------------- SUMMARY ----------------------------"
836 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
837 echo "Boards skipped: ${SKIP_CNT}"
839 echo "Boards compiled: ${TOTAL_CNT}"
840 if [ ${ERR_CNT} -gt 0 ] ; then
841 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
843 if [ ${WRN_CNT} -gt 0 ] ; then
844 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
846 echo "----------------------------------------------------------"
848 if [ $BUILD_MANY == 1 ] ; then
855 #-----------------------------------------------------------------------
857 # Build target groups selected by options, plus any command line args
858 set -- ${SELECTED} "$@"
859 # run PowerPC by default
860 [ $# = 0 ] && set -- powerpc